<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ClientCnxn.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">ClientCnxn.java</span></div><h1>ClientCnxn.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper;

import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.lang.Thread.UncaughtExceptionHandler;
import java.net.ConnectException;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketAddress;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;
import java.util.Set;
import java.util.concurrent.CopyOnWriteArraySet;
import java.util.concurrent.LinkedBlockingQueue;

import javax.security.auth.login.LoginException;
import javax.security.sasl.SaslException;

import org.apache.jute.BinaryInputArchive;
import org.apache.jute.BinaryOutputArchive;
import org.apache.jute.Record;
import org.apache.zookeeper.AsyncCallback.ACLCallback;
import org.apache.zookeeper.AsyncCallback.Children2Callback;
import org.apache.zookeeper.AsyncCallback.ChildrenCallback;
import org.apache.zookeeper.AsyncCallback.DataCallback;
import org.apache.zookeeper.AsyncCallback.MultiCallback;
import org.apache.zookeeper.AsyncCallback.StatCallback;
import org.apache.zookeeper.AsyncCallback.StringCallback;
import org.apache.zookeeper.AsyncCallback.VoidCallback;
import org.apache.zookeeper.OpResult.ErrorResult;
import org.apache.zookeeper.Watcher.Event;
import org.apache.zookeeper.Watcher.Event.EventType;
import org.apache.zookeeper.Watcher.Event.KeeperState;
import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.ZooKeeper.States;
import org.apache.zookeeper.ZooKeeper.WatchRegistration;
import org.apache.zookeeper.client.HostProvider;
import org.apache.zookeeper.client.ZooKeeperSaslClient;
import org.apache.zookeeper.proto.AuthPacket;
import org.apache.zookeeper.proto.ConnectRequest;
import org.apache.zookeeper.proto.CreateResponse;
import org.apache.zookeeper.proto.ExistsResponse;
import org.apache.zookeeper.proto.GetACLResponse;
import org.apache.zookeeper.proto.GetChildren2Response;
import org.apache.zookeeper.proto.GetChildrenResponse;
import org.apache.zookeeper.proto.GetDataResponse;
import org.apache.zookeeper.proto.GetSASLRequest;
import org.apache.zookeeper.proto.ReplyHeader;
import org.apache.zookeeper.proto.RequestHeader;
import org.apache.zookeeper.proto.SetACLResponse;
import org.apache.zookeeper.proto.SetDataResponse;
import org.apache.zookeeper.proto.SetWatches;
import org.apache.zookeeper.proto.WatcherEvent;
import org.apache.zookeeper.server.ByteBufferInputStream;
import org.apache.zookeeper.server.ZooKeeperThread;
import org.apache.zookeeper.server.ZooTrace;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This class manages the socket i/o for the client. ClientCnxn maintains a list
 * of available servers to connect to and &quot;transparently&quot; switches servers it is
 * connected to as needed.
 *
 */
public class ClientCnxn {
<span class="fc" id="L91">    private static final Logger LOG = LoggerFactory.getLogger(ClientCnxn.class);</span>

    private static final String ZK_SASL_CLIENT_USERNAME =
        &quot;zookeeper.sasl.client.username&quot;;

    /* ZOOKEEPER-706: If a session has a large number of watches set then
     * attempting to re-establish those watches after a connection loss may
     * fail due to the SetWatches request exceeding the server's configured
     * jute.maxBuffer value. To avoid this we instead split the watch
     * re-establishement across multiple SetWatches calls. This constant
     * controls the size of each call. It is set to 128kB to be conservative
     * with respect to the server's 1MB default for jute.maxBuffer.
     */
    private static final int SET_WATCHES_MAX_LENGTH = 128 * 1024;

    /** This controls whether automatic watch resetting is enabled.
     * Clients automatically reset watches during session reconnect, this
     * option allows the client to turn off this behavior by setting
     * the environment variable &quot;zookeeper.disableAutoWatchReset&quot; to &quot;true&quot; */
    private static boolean disableAutoWatchReset;
    static {
        // this var should not be public, but otw there is no easy way
        // to test
<span class="fc" id="L114">        disableAutoWatchReset =</span>
<span class="fc" id="L115">            Boolean.getBoolean(&quot;zookeeper.disableAutoWatchReset&quot;);</span>
<span class="pc bpc" id="L116" title="1 of 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L117">            LOG.debug(&quot;zookeeper.disableAutoWatchReset is &quot;</span>
                    + disableAutoWatchReset);
        }
    }

    static class AuthData {
<span class="fc" id="L123">        AuthData(String scheme, byte data[]) {</span>
<span class="fc" id="L124">            this.scheme = scheme;</span>
<span class="fc" id="L125">            this.data = data;</span>
<span class="fc" id="L126">        }</span>

        String scheme;

        byte data[];
    }

<span class="fc" id="L133">    private final CopyOnWriteArraySet&lt;AuthData&gt; authInfo = new CopyOnWriteArraySet&lt;AuthData&gt;();</span>

    /**
     * These are the packets that have been sent and are waiting for a response.
     */
<span class="fc" id="L138">    private final LinkedList&lt;Packet&gt; pendingQueue = new LinkedList&lt;Packet&gt;();</span>

    /**
     * These are the packets that need to be sent.
     */
<span class="fc" id="L143">    private final LinkedList&lt;Packet&gt; outgoingQueue = new LinkedList&lt;Packet&gt;();</span>

    private int connectTimeout;

    /**
     * The timeout in ms the client negotiated with the server. This is the
     * &quot;real&quot; timeout, not the timeout request by the client (which may have
     * been increased/decreased by the server which applies bounds to this
     * value.
     */
    private volatile int negotiatedSessionTimeout;

    private int readTimeout;

    private final int sessionTimeout;

    private final ZooKeeper zooKeeper;

    private final ClientWatchManager watcher;

    private long sessionId;

<span class="fc" id="L165">    private byte sessionPasswd[] = new byte[16];</span>

    /**
     * If true, the connection is allowed to go to r-o mode. This field's value
     * is sent, besides other data, during session creation handshake. If the
     * server on the other side of the wire is partitioned it'll accept
     * read-only clients only.
     */
    private boolean readOnly;

    final String chrootPath;

    final SendThread sendThread;

    final EventThread eventThread;

    /**
     * Set to true when close is called. Latches the connection such that we
     * don't attempt to re-connect to the server if in the middle of closing the
     * connection (client sends session disconnect to server as part of close
     * operation)
     */
<span class="fc" id="L187">    private volatile boolean closing = false;</span>
    
    /**
     * A set of ZooKeeper hosts this client could connect to.
     */
    private final HostProvider hostProvider;

    /**
     * Is set to true when a connection to a r/w server is established for the
     * first time; never changed afterwards.
     * &lt;p&gt;
     * Is used to handle situations when client without sessionId connects to a
     * read-only server. Such client receives &quot;fake&quot; sessionId from read-only
     * server, but this sessionId is invalid for other servers. So when such
     * client finds a r/w server, it sends 0 instead of fake sessionId during
     * connection handshake and establishes new, valid session.
     * &lt;p&gt;
     * If this field is false (which implies we haven't seen r/w server before)
     * then non-zero sessionId is fake, otherwise it is valid.
     */
<span class="fc" id="L207">    volatile boolean seenRwServerBefore = false;</span>


    public ZooKeeperSaslClient zooKeeperSaslClient;

    public long getSessionId() {
<span class="fc" id="L213">        return sessionId;</span>
    }

    public byte[] getSessionPasswd() {
<span class="fc" id="L217">        return sessionPasswd;</span>
    }

    public int getSessionTimeout() {
<span class="fc" id="L221">        return negotiatedSessionTimeout;</span>
    }

    @Override
    public String toString() {
<span class="fc" id="L226">        StringBuilder sb = new StringBuilder();</span>

<span class="fc" id="L228">        SocketAddress local = sendThread.getClientCnxnSocket().getLocalSocketAddress();</span>
<span class="fc" id="L229">        SocketAddress remote = sendThread.getClientCnxnSocket().getRemoteSocketAddress();</span>
<span class="fc" id="L230">        sb</span>
<span class="fc" id="L231">            .append(&quot;sessionid:0x&quot;).append(Long.toHexString(getSessionId()))</span>
<span class="fc" id="L232">            .append(&quot; local:&quot;).append(local)</span>
<span class="fc" id="L233">            .append(&quot; remoteserver:&quot;).append(remote)</span>
<span class="fc" id="L234">            .append(&quot; lastZxid:&quot;).append(lastZxid)</span>
<span class="fc" id="L235">            .append(&quot; xid:&quot;).append(xid)</span>
<span class="fc" id="L236">            .append(&quot; sent:&quot;).append(sendThread.getClientCnxnSocket().getSentCount())</span>
<span class="fc" id="L237">            .append(&quot; recv:&quot;).append(sendThread.getClientCnxnSocket().getRecvCount())</span>
<span class="fc" id="L238">            .append(&quot; queuedpkts:&quot;).append(outgoingQueue.size())</span>
<span class="fc" id="L239">            .append(&quot; pendingresp:&quot;).append(pendingQueue.size())</span>
<span class="fc" id="L240">            .append(&quot; queuedevents:&quot;).append(eventThread.waitingEvents.size());</span>

<span class="fc" id="L242">        return sb.toString();</span>
    }

    /**
     * This class allows us to pass the headers and the relevant records around.
     */
    static class Packet {
        RequestHeader requestHeader;

        ReplyHeader replyHeader;

        Record request;

        Record response;

        ByteBuffer bb;

        /** Client's view of the path (may differ due to chroot) **/
        String clientPath;
        /** Servers's view of the path (may differ due to chroot) **/
        String serverPath;

        boolean finished;

        AsyncCallback cb;

        Object ctx;

        WatchRegistration watchRegistration;

        public boolean readOnly;

        /** Convenience ctor */
        Packet(RequestHeader requestHeader, ReplyHeader replyHeader,
               Record request, Record response,
               WatchRegistration watchRegistration) {
<span class="fc" id="L278">            this(requestHeader, replyHeader, request, response,</span>
                 watchRegistration, false);
<span class="fc" id="L280">        }</span>

        Packet(RequestHeader requestHeader, ReplyHeader replyHeader,
               Record request, Record response,
<span class="fc" id="L284">               WatchRegistration watchRegistration, boolean readOnly) {</span>

<span class="fc" id="L286">            this.requestHeader = requestHeader;</span>
<span class="fc" id="L287">            this.replyHeader = replyHeader;</span>
<span class="fc" id="L288">            this.request = request;</span>
<span class="fc" id="L289">            this.response = response;</span>
<span class="fc" id="L290">            this.readOnly = readOnly;</span>
<span class="fc" id="L291">            this.watchRegistration = watchRegistration;</span>
<span class="fc" id="L292">        }</span>

        public void createBB() {
            try {
<span class="fc" id="L296">                ByteArrayOutputStream baos = new ByteArrayOutputStream();</span>
<span class="fc" id="L297">                BinaryOutputArchive boa = BinaryOutputArchive.getArchive(baos);</span>
<span class="fc" id="L298">                boa.writeInt(-1, &quot;len&quot;); // We'll fill this in later</span>
<span class="fc bfc" id="L299" title="All 2 branches covered.">                if (requestHeader != null) {</span>
<span class="fc" id="L300">                    requestHeader.serialize(boa, &quot;header&quot;);</span>
                }
<span class="fc bfc" id="L302" title="All 2 branches covered.">                if (request instanceof ConnectRequest) {</span>
<span class="fc" id="L303">                    request.serialize(boa, &quot;connect&quot;);</span>
                    // append &quot;am-I-allowed-to-be-readonly&quot; flag
<span class="fc" id="L305">                    boa.writeBool(readOnly, &quot;readOnly&quot;);</span>
<span class="fc bfc" id="L306" title="All 2 branches covered.">                } else if (request != null) {</span>
<span class="fc" id="L307">                    request.serialize(boa, &quot;request&quot;);</span>
                }
<span class="fc" id="L309">                baos.close();</span>
<span class="fc" id="L310">                this.bb = ByteBuffer.wrap(baos.toByteArray());</span>
<span class="fc" id="L311">                this.bb.putInt(this.bb.capacity() - 4);</span>
<span class="fc" id="L312">                this.bb.rewind();</span>
<span class="nc" id="L313">            } catch (IOException e) {</span>
<span class="nc" id="L314">                LOG.warn(&quot;Ignoring unexpected exception&quot;, e);</span>
<span class="fc" id="L315">            }</span>
<span class="fc" id="L316">        }</span>

        @Override
        public String toString() {
<span class="nc" id="L320">            StringBuilder sb = new StringBuilder();</span>

<span class="nc" id="L322">            sb.append(&quot;clientPath:&quot; + clientPath);</span>
<span class="nc" id="L323">            sb.append(&quot; serverPath:&quot; + serverPath);</span>
<span class="nc" id="L324">            sb.append(&quot; finished:&quot; + finished);</span>

<span class="nc" id="L326">            sb.append(&quot; header:: &quot; + requestHeader);</span>
<span class="nc" id="L327">            sb.append(&quot; replyHeader:: &quot; + replyHeader);</span>
<span class="nc" id="L328">            sb.append(&quot; request:: &quot; + request);</span>
<span class="nc" id="L329">            sb.append(&quot; response:: &quot; + response);</span>

            // jute toString is horrible, remove unnecessary newlines
<span class="nc" id="L332">            return sb.toString().replaceAll(&quot;\r*\n+&quot;, &quot; &quot;);</span>
        }
    }

    /**
     * Creates a connection object. The actual network connect doesn't get
     * established until needed. The start() instance method must be called
     * subsequent to construction.
     *
     * @param chrootPath - the chroot of this client. Should be removed from this Class in ZOOKEEPER-838
     * @param hostProvider
     *                the list of ZooKeeper servers to connect to
     * @param sessionTimeout
     *                the timeout for connections.
     * @param zooKeeper
     *                the zookeeper object that this connection is related to.
     * @param watcher watcher for this connection
     * @param clientCnxnSocket
     *                the socket implementation used (e.g. NIO/Netty)
     * @param canBeReadOnly
     *                whether the connection is allowed to go to read-only
     *                mode in case of partitioning
     * @throws IOException
     */
    public ClientCnxn(String chrootPath, HostProvider hostProvider, int sessionTimeout, ZooKeeper zooKeeper,
            ClientWatchManager watcher, ClientCnxnSocket clientCnxnSocket, boolean canBeReadOnly)
            throws IOException {
<span class="fc" id="L359">        this(chrootPath, hostProvider, sessionTimeout, zooKeeper, watcher,</span>
             clientCnxnSocket, 0, new byte[16], canBeReadOnly);
<span class="fc" id="L361">    }</span>

    /**
     * Creates a connection object. The actual network connect doesn't get
     * established until needed. The start() instance method must be called
     * subsequent to construction.
     *
     * @param chrootPath - the chroot of this client. Should be removed from this Class in ZOOKEEPER-838
     * @param hostProvider
     *                the list of ZooKeeper servers to connect to
     * @param sessionTimeout
     *                the timeout for connections.
     * @param zooKeeper
     *                the zookeeper object that this connection is related to.
     * @param watcher watcher for this connection
     * @param clientCnxnSocket
     *                the socket implementation used (e.g. NIO/Netty)
     * @param sessionId session id if re-establishing session
     * @param sessionPasswd session passwd if re-establishing session
     * @param canBeReadOnly
     *                whether the connection is allowed to go to read-only
     *                mode in case of partitioning
     * @throws IOException
     */
    public ClientCnxn(String chrootPath, HostProvider hostProvider, int sessionTimeout, ZooKeeper zooKeeper,
            ClientWatchManager watcher, ClientCnxnSocket clientCnxnSocket,
<span class="fc" id="L387">            long sessionId, byte[] sessionPasswd, boolean canBeReadOnly) {</span>
<span class="fc" id="L388">        this.zooKeeper = zooKeeper;</span>
<span class="fc" id="L389">        this.watcher = watcher;</span>
<span class="fc" id="L390">        this.sessionId = sessionId;</span>
<span class="fc" id="L391">        this.sessionPasswd = sessionPasswd;</span>
<span class="fc" id="L392">        this.sessionTimeout = sessionTimeout;</span>
<span class="fc" id="L393">        this.hostProvider = hostProvider;</span>
<span class="fc" id="L394">        this.chrootPath = chrootPath;</span>

<span class="fc" id="L396">        connectTimeout = sessionTimeout / hostProvider.size();</span>
<span class="fc" id="L397">        readTimeout = sessionTimeout * 2 / 3;</span>
<span class="fc" id="L398">        readOnly = canBeReadOnly;</span>

<span class="fc" id="L400">        sendThread = new SendThread(clientCnxnSocket);</span>
<span class="fc" id="L401">        eventThread = new EventThread();</span>

<span class="fc" id="L403">    }</span>

    /**
     * tests use this to check on reset of watches
     * @return if the auto reset of watches are disabled
     */
    public static boolean getDisableAutoResetWatch() {
<span class="fc" id="L410">        return disableAutoWatchReset;</span>
    }
    /**
     * tests use this to set the auto reset
     * @param b the value to set disable watches to
     */
    public static void setDisableAutoResetWatch(boolean b) {
<span class="fc" id="L417">        disableAutoWatchReset = b;</span>
<span class="fc" id="L418">    }</span>
    public void start() {
<span class="fc" id="L420">        sendThread.start();</span>
<span class="fc" id="L421">        eventThread.start();</span>
<span class="fc" id="L422">    }</span>

<span class="fc" id="L424">    private Object eventOfDeath = new Object();</span>

    private static class WatcherSetEventPair {
        private final Set&lt;Watcher&gt; watchers;
        private final WatchedEvent event;

<span class="fc" id="L430">        public WatcherSetEventPair(Set&lt;Watcher&gt; watchers, WatchedEvent event) {</span>
<span class="fc" id="L431">            this.watchers = watchers;</span>
<span class="fc" id="L432">            this.event = event;</span>
<span class="fc" id="L433">        }</span>
    }

    /**
     * Guard against creating &quot;-EventThread-EventThread-EventThread-...&quot; thread
     * names when ZooKeeper object is being created from within a watcher.
     * See ZOOKEEPER-795 for details.
     */
    private static String makeThreadName(String suffix) {
<span class="fc" id="L442">        String name = Thread.currentThread().getName().</span>
<span class="fc" id="L443">            replaceAll(&quot;-EventThread&quot;, &quot;&quot;);</span>
<span class="fc" id="L444">        return name + suffix;</span>
    }

    class EventThread extends ZooKeeperThread {
<span class="fc" id="L448">        private final LinkedBlockingQueue&lt;Object&gt; waitingEvents =</span>
            new LinkedBlockingQueue&lt;Object&gt;();

        /** This is really the queued session state until the event
         * thread actually processes the event and hands it to the watcher.
         * But for all intents and purposes this is the state.
         */
<span class="fc" id="L455">        private volatile KeeperState sessionState = KeeperState.Disconnected;</span>

<span class="fc" id="L457">       private volatile boolean wasKilled = false;</span>
<span class="fc" id="L458">       private volatile boolean isRunning = false;</span>

<span class="fc" id="L460">        EventThread() {</span>
<span class="fc" id="L461">            super(makeThreadName(&quot;-EventThread&quot;));</span>
<span class="fc" id="L462">            setDaemon(true);</span>
<span class="fc" id="L463">        }</span>

        public void queueEvent(WatchedEvent event) {
<span class="fc bfc" id="L466" title="All 2 branches covered.">            if (event.getType() == EventType.None</span>
<span class="fc bfc" id="L467" title="All 2 branches covered.">                    &amp;&amp; sessionState == event.getState()) {</span>
<span class="fc" id="L468">                return;</span>
            }
<span class="fc" id="L470">            sessionState = event.getState();</span>

            // materialize the watchers based on the event
<span class="fc" id="L473">            WatcherSetEventPair pair = new WatcherSetEventPair(</span>
<span class="fc" id="L474">                    watcher.materialize(event.getState(), event.getType(),</span>
<span class="fc" id="L475">                            event.getPath()),</span>
                            event);
            // queue the pair (watch set &amp; event) for later processing
<span class="fc" id="L478">            waitingEvents.add(pair);</span>
<span class="fc" id="L479">        }</span>

       public void queuePacket(Packet packet) {
<span class="fc bfc" id="L482" title="All 2 branches covered.">          if (wasKilled) {</span>
<span class="fc" id="L483">             synchronized (waitingEvents) {</span>
<span class="pc bpc" id="L484" title="1 of 2 branches missed.">                if (isRunning) waitingEvents.add(packet);</span>
<span class="fc" id="L485">                else processEvent(packet);</span>
<span class="pc" id="L486">             }</span>
          } else {
<span class="fc" id="L488">             waitingEvents.add(packet);</span>
          }
<span class="fc" id="L490">       }</span>

        public void queueEventOfDeath() {
<span class="fc" id="L493">            waitingEvents.add(eventOfDeath);</span>
<span class="fc" id="L494">        }</span>

        @Override
        public void run() {
           try {
<span class="fc" id="L499">              isRunning = true;</span>
              while (true) {
<span class="fc" id="L501">                 Object event = waitingEvents.take();</span>
<span class="fc bfc" id="L502" title="All 2 branches covered.">                 if (event == eventOfDeath) {</span>
<span class="fc" id="L503">                    wasKilled = true;</span>
                 } else {
<span class="fc" id="L505">                    processEvent(event);</span>
                 }
<span class="fc bfc" id="L507" title="All 2 branches covered.">                 if (wasKilled)</span>
<span class="fc" id="L508">                    synchronized (waitingEvents) {</span>
<span class="fc bfc" id="L509" title="All 2 branches covered.">                       if (waitingEvents.isEmpty()) {</span>
<span class="fc" id="L510">                          isRunning = false;</span>
<span class="fc" id="L511">                          break;</span>
                       }
<span class="pc" id="L513">                    }</span>
<span class="fc" id="L514">              }</span>
<span class="nc" id="L515">           } catch (InterruptedException e) {</span>
<span class="nc" id="L516">              LOG.error(&quot;Event thread exiting due to interruption&quot;, e);</span>
<span class="fc" id="L517">           }</span>

<span class="fc" id="L519">            LOG.info(&quot;EventThread shut down for session: 0x{}&quot;,</span>
<span class="fc" id="L520">                     Long.toHexString(getSessionId()));</span>
<span class="fc" id="L521">        }</span>

       private void processEvent(Object event) {
          try {
<span class="fc bfc" id="L525" title="All 2 branches covered.">              if (event instanceof WatcherSetEventPair) {</span>
                  // each watcher will process the event
<span class="fc" id="L527">                  WatcherSetEventPair pair = (WatcherSetEventPair) event;</span>
<span class="fc bfc" id="L528" title="All 2 branches covered.">                  for (Watcher watcher : pair.watchers) {</span>
                      try {
<span class="fc" id="L530">                          watcher.process(pair.event);</span>
<span class="nc" id="L531">                      } catch (Throwable t) {</span>
<span class="nc" id="L532">                          LOG.error(&quot;Error while calling watcher &quot;, t);</span>
<span class="fc" id="L533">                      }</span>
<span class="fc" id="L534">                  }</span>
<span class="fc" id="L535">              } else {</span>
<span class="fc" id="L536">                  Packet p = (Packet) event;</span>
<span class="fc" id="L537">                  int rc = 0;</span>
<span class="fc" id="L538">                  String clientPath = p.clientPath;</span>
<span class="fc bfc" id="L539" title="All 2 branches covered.">                  if (p.replyHeader.getErr() != 0) {</span>
<span class="fc" id="L540">                      rc = p.replyHeader.getErr();</span>
                  }
<span class="pc bpc" id="L542" title="1 of 2 branches missed.">                  if (p.cb == null) {</span>
<span class="nc" id="L543">                      LOG.warn(&quot;Somehow a null cb got to EventThread!&quot;);</span>
<span class="pc bpc" id="L544" title="1 of 6 branches missed.">                  } else if (p.response instanceof ExistsResponse</span>
                          || p.response instanceof SetDataResponse
                          || p.response instanceof SetACLResponse) {
<span class="fc" id="L547">                      StatCallback cb = (StatCallback) p.cb;</span>
<span class="fc bfc" id="L548" title="All 2 branches covered.">                      if (rc == 0) {</span>
<span class="pc bpc" id="L549" title="1 of 2 branches missed.">                          if (p.response instanceof ExistsResponse) {</span>
<span class="nc" id="L550">                              cb.processResult(rc, clientPath, p.ctx,</span>
                                      ((ExistsResponse) p.response)
<span class="nc" id="L552">                                              .getStat());</span>
<span class="fc bfc" id="L553" title="All 2 branches covered.">                          } else if (p.response instanceof SetDataResponse) {</span>
<span class="fc" id="L554">                              cb.processResult(rc, clientPath, p.ctx,</span>
                                      ((SetDataResponse) p.response)
<span class="fc" id="L556">                                              .getStat());</span>
<span class="pc bpc" id="L557" title="1 of 2 branches missed.">                          } else if (p.response instanceof SetACLResponse) {</span>
<span class="fc" id="L558">                              cb.processResult(rc, clientPath, p.ctx,</span>
                                      ((SetACLResponse) p.response)
<span class="fc" id="L560">                                              .getStat());</span>
                          }
                      } else {
<span class="fc" id="L563">                          cb.processResult(rc, clientPath, p.ctx, null);</span>
                      }
<span class="fc bfc" id="L565" title="All 2 branches covered.">                  } else if (p.response instanceof GetDataResponse) {</span>
<span class="fc" id="L566">                      DataCallback cb = (DataCallback) p.cb;</span>
<span class="fc" id="L567">                      GetDataResponse rsp = (GetDataResponse) p.response;</span>
<span class="fc bfc" id="L568" title="All 2 branches covered.">                      if (rc == 0) {</span>
<span class="fc" id="L569">                          cb.processResult(rc, clientPath, p.ctx, rsp</span>
<span class="fc" id="L570">                                  .getData(), rsp.getStat());</span>
                      } else {
<span class="fc" id="L572">                          cb.processResult(rc, clientPath, p.ctx, null,</span>
                                  null);
                      }
<span class="fc bfc" id="L575" title="All 2 branches covered.">                  } else if (p.response instanceof GetACLResponse) {</span>
<span class="fc" id="L576">                      ACLCallback cb = (ACLCallback) p.cb;</span>
<span class="fc" id="L577">                      GetACLResponse rsp = (GetACLResponse) p.response;</span>
<span class="fc bfc" id="L578" title="All 2 branches covered.">                      if (rc == 0) {</span>
<span class="fc" id="L579">                          cb.processResult(rc, clientPath, p.ctx, rsp</span>
<span class="fc" id="L580">                                  .getAcl(), rsp.getStat());</span>
                      } else {
<span class="fc" id="L582">                          cb.processResult(rc, clientPath, p.ctx, null,</span>
                                  null);
                      }
<span class="fc bfc" id="L585" title="All 2 branches covered.">                  } else if (p.response instanceof GetChildrenResponse) {</span>
<span class="fc" id="L586">                      ChildrenCallback cb = (ChildrenCallback) p.cb;</span>
<span class="fc" id="L587">                      GetChildrenResponse rsp = (GetChildrenResponse) p.response;</span>
<span class="fc bfc" id="L588" title="All 2 branches covered.">                      if (rc == 0) {</span>
<span class="fc" id="L589">                          cb.processResult(rc, clientPath, p.ctx, rsp</span>
<span class="fc" id="L590">                                  .getChildren());</span>
                      } else {
<span class="fc" id="L592">                          cb.processResult(rc, clientPath, p.ctx, null);</span>
                      }
<span class="fc bfc" id="L594" title="All 2 branches covered.">                  } else if (p.response instanceof GetChildren2Response) {</span>
<span class="fc" id="L595">                      Children2Callback cb = (Children2Callback) p.cb;</span>
<span class="fc" id="L596">                      GetChildren2Response rsp = (GetChildren2Response) p.response;</span>
<span class="fc bfc" id="L597" title="All 2 branches covered.">                      if (rc == 0) {</span>
<span class="fc" id="L598">                          cb.processResult(rc, clientPath, p.ctx, rsp</span>
<span class="fc" id="L599">                                  .getChildren(), rsp.getStat());</span>
                      } else {
<span class="fc" id="L601">                          cb.processResult(rc, clientPath, p.ctx, null, null);</span>
                      }
<span class="fc bfc" id="L603" title="All 2 branches covered.">                  } else if (p.response instanceof CreateResponse) {</span>
<span class="fc" id="L604">                      StringCallback cb = (StringCallback) p.cb;</span>
<span class="fc" id="L605">                      CreateResponse rsp = (CreateResponse) p.response;</span>
<span class="fc bfc" id="L606" title="All 2 branches covered.">                      if (rc == 0) {</span>
<span class="fc bfc" id="L607" title="All 2 branches covered.">                          cb.processResult(rc, clientPath, p.ctx,</span>
                                  (chrootPath == null
<span class="fc" id="L609">                                          ? rsp.getPath()</span>
<span class="fc" id="L610">                                          : rsp.getPath()</span>
<span class="fc" id="L611">                                    .substring(chrootPath.length())));</span>
                      } else {
<span class="fc" id="L613">                          cb.processResult(rc, clientPath, p.ctx, null);</span>
                      }
<span class="fc bfc" id="L615" title="All 2 branches covered.">                  } else if (p.response instanceof MultiResponse) {</span>
<span class="fc" id="L616">                          MultiCallback cb = (MultiCallback) p.cb;</span>
<span class="fc" id="L617">                          MultiResponse rsp = (MultiResponse) p.response;</span>
<span class="pc bpc" id="L618" title="1 of 2 branches missed.">                          if (rc == 0) {</span>
<span class="fc" id="L619">                                  List&lt;OpResult&gt; results = rsp.getResultList();</span>
<span class="fc" id="L620">                                  int newRc = rc;</span>
<span class="fc bfc" id="L621" title="All 2 branches covered.">                                  for (OpResult result : results) {</span>
<span class="fc bfc" id="L622" title="All 2 branches covered.">                                          if (result instanceof ErrorResult</span>
<span class="fc" id="L623">                                              &amp;&amp; KeeperException.Code.OK.intValue()</span>
<span class="fc bfc" id="L624" title="All 2 branches covered.">                                                  != (newRc = ((ErrorResult) result).getErr())) {</span>
<span class="fc" id="L625">                                                  break;</span>
                                          }
<span class="fc" id="L627">                                  }</span>
<span class="fc" id="L628">                                  cb.processResult(newRc, clientPath, p.ctx, results);</span>
<span class="fc" id="L629">                          } else {</span>
<span class="nc" id="L630">                                  cb.processResult(rc, clientPath, p.ctx, null);</span>
                          }
<span class="pc bpc" id="L632" title="1 of 2 branches missed.">                  }  else if (p.cb instanceof VoidCallback) {</span>
<span class="fc" id="L633">                      VoidCallback cb = (VoidCallback) p.cb;</span>
<span class="fc" id="L634">                      cb.processResult(rc, clientPath, p.ctx);</span>
                  }
              }
<span class="nc" id="L637">          } catch (Throwable t) {</span>
<span class="nc" id="L638">              LOG.error(&quot;Caught unexpected throwable&quot;, t);</span>
<span class="fc" id="L639">          }</span>
<span class="fc" id="L640">       }</span>
    }

    private void finishPacket(Packet p) {
<span class="fc bfc" id="L644" title="All 2 branches covered.">        if (p.watchRegistration != null) {</span>
<span class="fc" id="L645">            p.watchRegistration.register(p.replyHeader.getErr());</span>
        }

<span class="fc bfc" id="L648" title="All 2 branches covered.">        if (p.cb == null) {</span>
<span class="fc" id="L649">            synchronized (p) {</span>
<span class="fc" id="L650">                p.finished = true;</span>
<span class="fc" id="L651">                p.notifyAll();</span>
<span class="pc" id="L652">            }</span>
        } else {
<span class="fc" id="L654">            p.finished = true;</span>
<span class="fc" id="L655">            eventThread.queuePacket(p);</span>
        }
<span class="fc" id="L657">    }</span>

    private void conLossPacket(Packet p) {
<span class="fc bfc" id="L660" title="All 2 branches covered.">        if (p.replyHeader == null) {</span>
<span class="fc" id="L661">            return;</span>
        }
<span class="pc bfc" id="L663" title="All 3 branches covered.">        switch (state) {</span>
        case AUTH_FAILED:
<span class="fc" id="L665">            p.replyHeader.setErr(KeeperException.Code.AUTHFAILED.intValue());</span>
<span class="fc" id="L666">            break;</span>
        case CLOSED:
<span class="fc" id="L668">            p.replyHeader.setErr(KeeperException.Code.SESSIONEXPIRED.intValue());</span>
<span class="fc" id="L669">            break;</span>
        default:
<span class="fc" id="L671">            p.replyHeader.setErr(KeeperException.Code.CONNECTIONLOSS.intValue());</span>
        }
<span class="fc" id="L673">        finishPacket(p);</span>
<span class="fc" id="L674">    }</span>

    private volatile long lastZxid;

    public long getLastZxid() {
<span class="fc" id="L679">        return lastZxid;</span>
    }

    static class EndOfStreamException extends IOException {
        private static final long serialVersionUID = -5438877188796231422L;

        public EndOfStreamException(String msg) {
<span class="fc" id="L686">            super(msg);</span>
<span class="fc" id="L687">        }</span>
        
        @Override
        public String toString() {
<span class="nc" id="L691">            return &quot;EndOfStreamException: &quot; + getMessage();</span>
        }
    }

    private static class SessionTimeoutException extends IOException {
        private static final long serialVersionUID = 824482094072071178L;

        public SessionTimeoutException(String msg) {
<span class="fc" id="L699">            super(msg);</span>
<span class="fc" id="L700">        }</span>
    }
    
    private static class SessionExpiredException extends IOException {
        private static final long serialVersionUID = -1388816932076193249L;

        public SessionExpiredException(String msg) {
<span class="fc" id="L707">            super(msg);</span>
<span class="fc" id="L708">        }</span>
    }

    private static class RWServerFoundException extends IOException {
        private static final long serialVersionUID = 90431199887158758L;

        public RWServerFoundException(String msg) {
<span class="fc" id="L715">            super(msg);</span>
<span class="fc" id="L716">        }</span>
    }
    
<span class="fc" id="L719">    public static final int packetLen = Integer.getInteger(&quot;jute.maxbuffer&quot;,</span>
            4096 * 1024);

    /**
     * This class services the outgoing request queue and generates the heart
     * beats. It also spawns the ReadThread.
     */
    class SendThread extends ZooKeeperThread {
        private long lastPingSentNs;
        private final ClientCnxnSocket clientCnxnSocket;
<span class="fc" id="L729">        private Random r = new Random(System.nanoTime());        </span>
<span class="fc" id="L730">        private boolean isFirstConnect = true;</span>

        void readResponse(ByteBuffer incomingBuffer) throws IOException {
<span class="fc" id="L733">            ByteBufferInputStream bbis = new ByteBufferInputStream(</span>
                    incomingBuffer);
<span class="fc" id="L735">            BinaryInputArchive bbia = BinaryInputArchive.getArchive(bbis);</span>
<span class="fc" id="L736">            ReplyHeader replyHdr = new ReplyHeader();</span>

<span class="fc" id="L738">            replyHdr.deserialize(bbia, &quot;header&quot;);</span>
<span class="fc bfc" id="L739" title="All 2 branches covered.">            if (replyHdr.getXid() == -2) {</span>
                // -2 is the xid for pings
<span class="pc bpc" id="L741" title="1 of 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L742">                    LOG.debug(&quot;Got ping response for sessionid: 0x&quot;</span>
<span class="nc" id="L743">                            + Long.toHexString(sessionId)</span>
                            + &quot; after &quot;
<span class="nc" id="L745">                            + ((System.nanoTime() - lastPingSentNs) / 1000000)</span>
                            + &quot;ms&quot;);
                }
<span class="fc" id="L748">                return;</span>
            }
<span class="fc bfc" id="L750" title="All 2 branches covered.">            if (replyHdr.getXid() == -4) {</span>
                // -4 is the xid for AuthPacket               
<span class="fc bfc" id="L752" title="All 2 branches covered.">                if(replyHdr.getErr() == KeeperException.Code.AUTHFAILED.intValue()) {</span>
<span class="fc" id="L753">                    state = States.AUTH_FAILED;                    </span>
<span class="fc" id="L754">                    eventThread.queueEvent( new WatchedEvent(Watcher.Event.EventType.None, </span>
                            Watcher.Event.KeeperState.AuthFailed, null) );            		            		
                }
<span class="pc bpc" id="L757" title="1 of 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L758">                    LOG.debug(&quot;Got auth sessionid:0x&quot;</span>
<span class="nc" id="L759">                            + Long.toHexString(sessionId));</span>
                }
<span class="fc" id="L761">                return;</span>
            }
<span class="fc bfc" id="L763" title="All 2 branches covered.">            if (replyHdr.getXid() == -1) {</span>
                // -1 means notification
<span class="pc bpc" id="L765" title="1 of 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L766">                    LOG.debug(&quot;Got notification sessionid:0x&quot;</span>
<span class="nc" id="L767">                        + Long.toHexString(sessionId));</span>
                }
<span class="fc" id="L769">                WatcherEvent event = new WatcherEvent();</span>
<span class="fc" id="L770">                event.deserialize(bbia, &quot;response&quot;);</span>

                // convert from a server path to a client path
<span class="fc bfc" id="L773" title="All 2 branches covered.">                if (chrootPath != null) {</span>
<span class="fc" id="L774">                    String serverPath = event.getPath();</span>
<span class="fc bfc" id="L775" title="All 2 branches covered.">                    if(serverPath.compareTo(chrootPath)==0)</span>
<span class="fc" id="L776">                        event.setPath(&quot;/&quot;);</span>
<span class="pc bpc" id="L777" title="1 of 2 branches missed.">                    else if (serverPath.length() &gt; chrootPath.length())</span>
<span class="fc" id="L778">                        event.setPath(serverPath.substring(chrootPath.length()));</span>
                    else {
<span class="nc" id="L780">                    	LOG.warn(&quot;Got server path &quot; + event.getPath()</span>
                    			+ &quot; which is too short for chroot path &quot;
                    			+ chrootPath);
                    }
                }

<span class="fc" id="L786">                WatchedEvent we = new WatchedEvent(event);</span>
<span class="pc bpc" id="L787" title="1 of 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L788">                    LOG.debug(&quot;Got &quot; + we + &quot; for sessionid 0x&quot;</span>
<span class="nc" id="L789">                            + Long.toHexString(sessionId));</span>
                }

<span class="fc" id="L792">                eventThread.queueEvent( we );</span>
<span class="fc" id="L793">                return;</span>
            }

            // If SASL authentication is currently in progress, construct and
            // send a response packet immediately, rather than queuing a
            // response as with other packets.
<span class="fc bfc" id="L799" title="All 2 branches covered.">            if (clientTunneledAuthenticationInProgress()) {</span>
<span class="fc" id="L800">                GetSASLRequest request = new GetSASLRequest();</span>
<span class="fc" id="L801">                request.deserialize(bbia,&quot;token&quot;);</span>
<span class="fc" id="L802">                zooKeeperSaslClient.respondToServer(request.getToken(),</span>
                  ClientCnxn.this);
<span class="fc" id="L804">                return;</span>
            }

            Packet packet;
<span class="fc" id="L808">            synchronized (pendingQueue) {</span>
<span class="pc bpc" id="L809" title="1 of 2 branches missed.">                if (pendingQueue.size() == 0) {</span>
<span class="nc" id="L810">                    throw new IOException(&quot;Nothing in the queue, but got &quot;</span>
<span class="nc" id="L811">                            + replyHdr.getXid());</span>
                }
<span class="fc" id="L813">                packet = pendingQueue.remove();</span>
<span class="pc" id="L814">            }</span>
            /*
             * Since requests are processed in order, we better get a response
             * to the first request!
             */
            try {
<span class="pc bpc" id="L820" title="1 of 2 branches missed.">                if (packet.requestHeader.getXid() != replyHdr.getXid()) {</span>
<span class="nc" id="L821">                    packet.replyHeader.setErr(</span>
<span class="nc" id="L822">                            KeeperException.Code.CONNECTIONLOSS.intValue());</span>
<span class="nc" id="L823">                    throw new IOException(&quot;Xid out of order. Got Xid &quot;</span>
<span class="nc" id="L824">                            + replyHdr.getXid() + &quot; with err &quot; +</span>
<span class="nc" id="L825">                            + replyHdr.getErr() +</span>
                            &quot; expected Xid &quot;
<span class="nc" id="L827">                            + packet.requestHeader.getXid()</span>
                            + &quot; for a packet with details: &quot;
                            + packet );
                }

<span class="fc" id="L832">                packet.replyHeader.setXid(replyHdr.getXid());</span>
<span class="fc" id="L833">                packet.replyHeader.setErr(replyHdr.getErr());</span>
<span class="fc" id="L834">                packet.replyHeader.setZxid(replyHdr.getZxid());</span>
<span class="fc bfc" id="L835" title="All 2 branches covered.">                if (replyHdr.getZxid() &gt; 0) {</span>
<span class="fc" id="L836">                    lastZxid = replyHdr.getZxid();</span>
                }
<span class="fc bfc" id="L838" title="All 4 branches covered.">                if (packet.response != null &amp;&amp; replyHdr.getErr() == 0) {</span>
<span class="fc" id="L839">                    packet.response.deserialize(bbia, &quot;response&quot;);</span>
                }

<span class="pc bpc" id="L842" title="1 of 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L843">                    LOG.debug(&quot;Reading reply sessionid:0x&quot;</span>
<span class="nc" id="L844">                            + Long.toHexString(sessionId) + &quot;, packet:: &quot; + packet);</span>
                }
            } finally {
<span class="pc" id="L847">                finishPacket(packet);</span>
<span class="fc" id="L848">            }</span>
<span class="fc" id="L849">        }</span>

<span class="fc" id="L851">        SendThread(ClientCnxnSocket clientCnxnSocket) {</span>
<span class="fc" id="L852">            super(makeThreadName(&quot;-SendThread()&quot;));</span>
<span class="fc" id="L853">            state = States.CONNECTING;</span>
<span class="fc" id="L854">            this.clientCnxnSocket = clientCnxnSocket;</span>
<span class="fc" id="L855">            setDaemon(true);</span>
<span class="fc" id="L856">        }</span>

        // TODO: can not name this method getState since Thread.getState()
        // already exists
        // It would be cleaner to make class SendThread an implementation of
        // Runnable
        /**
         * Used by ClientCnxnSocket
         * 
         * @return
         */
        ZooKeeper.States getZkState() {
<span class="fc" id="L868">            return state;</span>
        }

        ClientCnxnSocket getClientCnxnSocket() {
<span class="fc" id="L872">            return clientCnxnSocket;</span>
        }

        void primeConnection() throws IOException {
<span class="fc" id="L876">            LOG.info(&quot;Socket connection established to &quot;</span>
<span class="fc" id="L877">                     + clientCnxnSocket.getRemoteSocketAddress()</span>
                     + &quot;, initiating session&quot;);
<span class="fc" id="L879">            isFirstConnect = false;</span>
<span class="fc bfc" id="L880" title="All 2 branches covered.">            long sessId = (seenRwServerBefore) ? sessionId : 0;</span>
<span class="fc" id="L881">            ConnectRequest conReq = new ConnectRequest(0, lastZxid,</span>
<span class="fc" id="L882">                    sessionTimeout, sessId, sessionPasswd);</span>
<span class="fc" id="L883">            synchronized (outgoingQueue) {</span>
                // We add backwards since we are pushing into the front
                // Only send if there's a pending watch
                // TODO: here we have the only remaining use of zooKeeper in
                // this class. It's to be eliminated!
<span class="fc bfc" id="L888" title="All 2 branches covered.">                if (!disableAutoWatchReset) {</span>
<span class="fc" id="L889">                    List&lt;String&gt; dataWatches = zooKeeper.getDataWatches();</span>
<span class="fc" id="L890">                    List&lt;String&gt; existWatches = zooKeeper.getExistWatches();</span>
<span class="fc" id="L891">                    List&lt;String&gt; childWatches = zooKeeper.getChildWatches();</span>
<span class="fc bfc" id="L892" title="All 2 branches covered.">                    if (!dataWatches.isEmpty()</span>
<span class="pc bpc" id="L893" title="1 of 4 branches missed.">                                || !existWatches.isEmpty() || !childWatches.isEmpty()) {</span>

<span class="fc" id="L895">                        Iterator&lt;String&gt; dataWatchesIter = prependChroot(dataWatches).iterator();</span>
<span class="fc" id="L896">                        Iterator&lt;String&gt; existWatchesIter = prependChroot(existWatches).iterator();</span>
<span class="fc" id="L897">                        Iterator&lt;String&gt; childWatchesIter = prependChroot(childWatches).iterator();</span>
<span class="fc" id="L898">                        long setWatchesLastZxid = lastZxid;</span>

<span class="fc bfc" id="L900" title="All 2 branches covered.">                        while (dataWatchesIter.hasNext()</span>
<span class="fc bfc" id="L901" title="All 4 branches covered.">                                       || existWatchesIter.hasNext() || childWatchesIter.hasNext()) {</span>
<span class="fc" id="L902">                            List&lt;String&gt; dataWatchesBatch = new ArrayList&lt;String&gt;();</span>
<span class="fc" id="L903">                            List&lt;String&gt; existWatchesBatch = new ArrayList&lt;String&gt;();</span>
<span class="fc" id="L904">                            List&lt;String&gt; childWatchesBatch = new ArrayList&lt;String&gt;();</span>
<span class="fc" id="L905">                            int batchLength = 0;</span>

                            // Note, we may exceed our max length by a bit when we add the last
                            // watch in the batch. This isn't ideal, but it makes the code simpler.
<span class="fc bfc" id="L909" title="All 2 branches covered.">                            while (batchLength &lt; SET_WATCHES_MAX_LENGTH) {</span>
                                final String watch;
<span class="fc bfc" id="L911" title="All 2 branches covered.">                                if (dataWatchesIter.hasNext()) {</span>
<span class="fc" id="L912">                                    watch = dataWatchesIter.next();</span>
<span class="fc" id="L913">                                    dataWatchesBatch.add(watch);</span>
<span class="fc bfc" id="L914" title="All 2 branches covered.">                                } else if (existWatchesIter.hasNext()) {</span>
<span class="fc" id="L915">                                    watch = existWatchesIter.next();</span>
<span class="fc" id="L916">                                    existWatchesBatch.add(watch);</span>
<span class="fc bfc" id="L917" title="All 2 branches covered.">                                } else if (childWatchesIter.hasNext()) {</span>
<span class="fc" id="L918">                                    watch = childWatchesIter.next();</span>
<span class="fc" id="L919">                                    childWatchesBatch.add(watch);</span>
                                } else {
                                    break;
                                }
<span class="fc" id="L923">                                batchLength += watch.length();</span>
<span class="fc" id="L924">                            }</span>

<span class="fc" id="L926">                            SetWatches sw = new SetWatches(setWatchesLastZxid,</span>
                                    dataWatchesBatch,
                                    existWatchesBatch,
                                    childWatchesBatch);
<span class="fc" id="L930">                            RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L931">                            h.setType(ZooDefs.OpCode.setWatches);</span>
<span class="fc" id="L932">                            h.setXid(-8);</span>
<span class="fc" id="L933">                            Packet packet = new Packet(h, new ReplyHeader(), sw, null, null);</span>
<span class="fc" id="L934">                            outgoingQueue.addFirst(packet);</span>
<span class="fc" id="L935">                        }</span>
                    }
                }

<span class="fc bfc" id="L939" title="All 2 branches covered.">                for (AuthData id : authInfo) {</span>
<span class="fc" id="L940">                    outgoingQueue.addFirst(new Packet(new RequestHeader(-4,</span>
                            OpCode.auth), null, new AuthPacket(0, id.scheme,
                            id.data), null, null));
<span class="fc" id="L943">                }</span>
<span class="fc" id="L944">                outgoingQueue.addFirst(new Packet(null, null, conReq,</span>
<span class="fc" id="L945">                            null, null, readOnly));</span>
<span class="pc" id="L946">            }</span>
<span class="fc" id="L947">            clientCnxnSocket.enableReadWriteOnly();</span>
<span class="pc bpc" id="L948" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L949">                LOG.debug(&quot;Session establishment request sent on &quot;</span>
<span class="nc" id="L950">                        + clientCnxnSocket.getRemoteSocketAddress());</span>
            }
<span class="fc" id="L952">        }</span>

        private List&lt;String&gt; prependChroot(List&lt;String&gt; paths) {
<span class="fc bfc" id="L955" title="All 4 branches covered.">            if (chrootPath != null &amp;&amp; !paths.isEmpty()) {</span>
<span class="fc bfc" id="L956" title="All 2 branches covered.">                for (int i = 0; i &lt; paths.size(); ++i) {</span>
<span class="fc" id="L957">                    String clientPath = paths.get(i);</span>
                    String serverPath;
                    // handle clientPath = &quot;/&quot;
<span class="fc bfc" id="L960" title="All 2 branches covered.">                    if (clientPath.length() == 1) {</span>
<span class="fc" id="L961">                        serverPath = chrootPath;</span>
                    } else {
<span class="fc" id="L963">                        serverPath = chrootPath + clientPath;</span>
                    }
<span class="fc" id="L965">                    paths.set(i, serverPath);</span>
                }
            }
<span class="fc" id="L968">            return paths;</span>
        }

        private void sendPing() {
<span class="fc" id="L972">            lastPingSentNs = System.nanoTime();</span>
<span class="fc" id="L973">            RequestHeader h = new RequestHeader(-2, OpCode.ping);</span>
<span class="fc" id="L974">            queuePacket(h, null, null, null, null, null, null, null, null);</span>
<span class="fc" id="L975">        }</span>

<span class="fc" id="L977">        private InetSocketAddress rwServerAddress = null;</span>

        private final static int minPingRwTimeout = 100;

        private final static int maxPingRwTimeout = 60000;

<span class="fc" id="L983">        private int pingRwTimeout = minPingRwTimeout;</span>

        // Set to true if and only if constructor of ZooKeeperSaslClient
        // throws a LoginException: see startConnect() below.
<span class="fc" id="L987">        private boolean saslLoginFailed = false;</span>

        private void startConnect() throws IOException {
<span class="fc" id="L990">            state = States.CONNECTING;</span>

            InetSocketAddress addr;
<span class="fc bfc" id="L993" title="All 2 branches covered.">            if (rwServerAddress != null) {</span>
<span class="fc" id="L994">                addr = rwServerAddress;</span>
<span class="fc" id="L995">                rwServerAddress = null;</span>
            } else {
<span class="fc" id="L997">                addr = hostProvider.next(1000);</span>
            }

<span class="fc" id="L1000">            setName(getName().replaceAll(&quot;\\(.*\\)&quot;,</span>
<span class="fc" id="L1001">                    &quot;(&quot; + addr.getHostName() + &quot;:&quot; + addr.getPort() + &quot;)&quot;));</span>
<span class="pc bpc" id="L1002" title="1 of 2 branches missed.">            if (ZooKeeperSaslClient.isEnabled()) {</span>
                try {
<span class="fc" id="L1004">                    String principalUserName = System.getProperty(</span>
                            ZK_SASL_CLIENT_USERNAME, &quot;zookeeper&quot;);
<span class="fc" id="L1006">                    zooKeeperSaslClient =</span>
                        new ZooKeeperSaslClient(
<span class="fc" id="L1008">                                principalUserName+&quot;/&quot;+addr.getHostName());</span>
<span class="fc" id="L1009">                } catch (LoginException e) {</span>
                    // An authentication error occurred when the SASL client tried to initialize:
                    // for Kerberos this means that the client failed to authenticate with the KDC.
                    // This is different from an authentication error that occurs during communication
                    // with the Zookeeper server, which is handled below.
<span class="fc" id="L1014">                    LOG.warn(&quot;SASL configuration failed: &quot; + e + &quot; Will continue connection to Zookeeper server without &quot;</span>
                      + &quot;SASL authentication, if Zookeeper server allows it.&quot;);
<span class="fc" id="L1016">                    eventThread.queueEvent(new WatchedEvent(</span>
                      Watcher.Event.EventType.None,
                      Watcher.Event.KeeperState.AuthFailed, null));
<span class="fc" id="L1019">                    saslLoginFailed = true;</span>
<span class="fc" id="L1020">                }</span>
            }
<span class="fc" id="L1022">            logStartConnect(addr);</span>

<span class="fc" id="L1024">            clientCnxnSocket.connect(addr);</span>
<span class="fc" id="L1025">        }</span>

        private void logStartConnect(InetSocketAddress addr) {
<span class="fc" id="L1028">            String msg = &quot;Opening socket connection to server &quot; + addr;</span>
<span class="fc bfc" id="L1029" title="All 2 branches covered.">            if (zooKeeperSaslClient != null) {</span>
<span class="fc" id="L1030">              msg += &quot;. &quot; + zooKeeperSaslClient.getConfigStatus();</span>
            }
<span class="fc" id="L1032">            LOG.info(msg);</span>
<span class="fc" id="L1033">        }</span>

        private static final String RETRY_CONN_MSG =
            &quot;, closing socket connection and attempting reconnect&quot;;
        
        @Override
        public void run() {
<span class="fc" id="L1040">            clientCnxnSocket.introduce(this,sessionId);</span>
<span class="fc" id="L1041">            clientCnxnSocket.updateNow();</span>
<span class="fc" id="L1042">            clientCnxnSocket.updateLastSendAndHeard();</span>
            int to;
<span class="fc" id="L1044">            long lastPingRwServer = System.currentTimeMillis();</span>
<span class="fc" id="L1045">            final int MAX_SEND_PING_INTERVAL = 10000; //10 seconds</span>
<span class="fc bfc" id="L1046" title="All 2 branches covered.">            while (state.isAlive()) {</span>
                try {
<span class="fc bfc" id="L1048" title="All 2 branches covered.">                    if (!clientCnxnSocket.isConnected()) {</span>
<span class="fc bfc" id="L1049" title="All 2 branches covered.">                        if(!isFirstConnect){</span>
                            try {
<span class="fc" id="L1051">                                Thread.sleep(r.nextInt(1000));</span>
<span class="nc" id="L1052">                            } catch (InterruptedException e) {</span>
<span class="nc" id="L1053">                                LOG.warn(&quot;Unexpected exception&quot;, e);</span>
<span class="fc" id="L1054">                            }</span>
                        }
                        // don't re-establish connection if we are closing
<span class="pc bpc" id="L1057" title="1 of 4 branches missed.">                        if (closing || !state.isAlive()) {</span>
<span class="fc" id="L1058">                            break;</span>
                        }
<span class="fc" id="L1060">                        startConnect();</span>
<span class="fc" id="L1061">                        clientCnxnSocket.updateLastSendAndHeard();</span>
                    }

<span class="fc bfc" id="L1064" title="All 2 branches covered.">                    if (state.isConnected()) {</span>
                        // determine whether we need to send an AuthFailed event.
<span class="fc bfc" id="L1066" title="All 2 branches covered.">                        if (zooKeeperSaslClient != null) {</span>
<span class="fc" id="L1067">                            boolean sendAuthEvent = false;</span>
<span class="fc bfc" id="L1068" title="All 2 branches covered.">                            if (zooKeeperSaslClient.getSaslState() == ZooKeeperSaslClient.SaslState.INITIAL) {</span>
                                try {
<span class="fc" id="L1070">                                    zooKeeperSaslClient.initialize(ClientCnxn.this);</span>
<span class="nc" id="L1071">                                } catch (SaslException e) {</span>
<span class="nc" id="L1072">                                   LOG.error(&quot;SASL authentication with Zookeeper Quorum member failed: &quot; + e);</span>
<span class="nc" id="L1073">                                    state = States.AUTH_FAILED;</span>
<span class="nc" id="L1074">                                    sendAuthEvent = true;</span>
<span class="fc" id="L1075">                                }</span>
                            }
<span class="fc" id="L1077">                            KeeperState authState = zooKeeperSaslClient.getKeeperState();</span>
<span class="fc bfc" id="L1078" title="All 2 branches covered.">                            if (authState != null) {</span>
<span class="fc bfc" id="L1079" title="All 2 branches covered.">                                if (authState == KeeperState.AuthFailed) {</span>
                                    // An authentication error occurred during authentication with the Zookeeper Server.
<span class="fc" id="L1081">                                    state = States.AUTH_FAILED;</span>
<span class="fc" id="L1082">                                    sendAuthEvent = true;</span>
                                } else {
<span class="pc bpc" id="L1084" title="1 of 2 branches missed.">                                    if (authState == KeeperState.SaslAuthenticated) {</span>
<span class="fc" id="L1085">                                        sendAuthEvent = true;</span>
                                    }
                                }
                            }

<span class="fc bfc" id="L1090" title="All 2 branches covered.">                            if (sendAuthEvent == true) {</span>
<span class="fc" id="L1091">                                eventThread.queueEvent(new WatchedEvent(</span>
                                      Watcher.Event.EventType.None,
                                      authState,null));
                            }
                        }
<span class="fc" id="L1096">                        to = readTimeout - clientCnxnSocket.getIdleRecv();</span>
                    } else {
<span class="fc" id="L1098">                        to = connectTimeout - clientCnxnSocket.getIdleRecv();</span>
                    }
                    
<span class="fc bfc" id="L1101" title="All 2 branches covered.">                    if (to &lt;= 0) {</span>
                        String warnInfo;
<span class="fc" id="L1103">                        warnInfo = &quot;Client session timed out, have not heard from server in &quot;</span>
<span class="fc" id="L1104">                            + clientCnxnSocket.getIdleRecv()</span>
                            + &quot;ms&quot;
                            + &quot; for sessionid 0x&quot;
<span class="fc" id="L1107">                            + Long.toHexString(sessionId);</span>
<span class="fc" id="L1108">                        LOG.warn(warnInfo);</span>
<span class="fc" id="L1109">                        throw new SessionTimeoutException(warnInfo);</span>
                    }
<span class="fc bfc" id="L1111" title="All 2 branches covered.">                    if (state.isConnected()) {</span>
                    	//1000(1 second) is to prevent race condition missing to send the second ping
                    	//also make sure not to send too many pings when readTimeout is small 
<span class="fc" id="L1114">                        int timeToNextPing = readTimeout / 2 - clientCnxnSocket.getIdleSend() - </span>
<span class="fc bfc" id="L1115" title="All 2 branches covered.">                        		((clientCnxnSocket.getIdleSend() &gt; 1000) ? 1000 : 0);</span>
                        //send a ping request either time is due or no packet sent out within MAX_SEND_PING_INTERVAL
<span class="pc bpc" id="L1117" title="1 of 4 branches missed.">                        if (timeToNextPing &lt;= 0 || clientCnxnSocket.getIdleSend() &gt; MAX_SEND_PING_INTERVAL) {</span>
<span class="fc" id="L1118">                            sendPing();</span>
<span class="fc" id="L1119">                            clientCnxnSocket.updateLastSend();</span>
                        } else {
<span class="fc bfc" id="L1121" title="All 2 branches covered.">                            if (timeToNextPing &lt; to) {</span>
<span class="fc" id="L1122">                                to = timeToNextPing;</span>
                            }
                        }
                    }

                    // If we are in read-only mode, seek for read/write server
<span class="fc bfc" id="L1128" title="All 2 branches covered.">                    if (state == States.CONNECTEDREADONLY) {</span>
<span class="fc" id="L1129">                        long now = System.currentTimeMillis();</span>
<span class="fc" id="L1130">                        int idlePingRwServer = (int) (now - lastPingRwServer);</span>
<span class="fc bfc" id="L1131" title="All 2 branches covered.">                        if (idlePingRwServer &gt;= pingRwTimeout) {</span>
<span class="fc" id="L1132">                            lastPingRwServer = now;</span>
<span class="fc" id="L1133">                            idlePingRwServer = 0;</span>
<span class="fc" id="L1134">                            pingRwTimeout =</span>
<span class="fc" id="L1135">                                Math.min(2*pingRwTimeout, maxPingRwTimeout);</span>
<span class="fc" id="L1136">                            pingRwServer();</span>
                        }
<span class="fc" id="L1138">                        to = Math.min(to, pingRwTimeout - idlePingRwServer);</span>
                    }

<span class="fc" id="L1141">                    clientCnxnSocket.doTransport(to, pendingQueue, outgoingQueue, ClientCnxn.this);</span>
<span class="fc" id="L1142">                } catch (Throwable e) {</span>
<span class="fc bfc" id="L1143" title="All 2 branches covered.">                    if (closing) {</span>
<span class="pc bpc" id="L1144" title="1 of 2 branches missed.">                        if (LOG.isDebugEnabled()) {</span>
                            // closing so this is expected
<span class="nc" id="L1146">                            LOG.debug(&quot;An exception was thrown while closing send thread for session 0x&quot;</span>
<span class="nc" id="L1147">                                    + Long.toHexString(getSessionId())</span>
<span class="nc" id="L1148">                                    + &quot; : &quot; + e.getMessage());</span>
                        }
<span class="fc" id="L1150">                        break;</span>
                    } else {
                        // this is ugly, you have a better way speak up
<span class="fc bfc" id="L1153" title="All 2 branches covered.">                        if (e instanceof SessionExpiredException) {</span>
<span class="fc" id="L1154">                            LOG.info(e.getMessage() + &quot;, closing socket connection&quot;);</span>
<span class="fc bfc" id="L1155" title="All 2 branches covered.">                        } else if (e instanceof SessionTimeoutException) {</span>
<span class="fc" id="L1156">                            LOG.info(e.getMessage() + RETRY_CONN_MSG);</span>
<span class="fc bfc" id="L1157" title="All 2 branches covered.">                        } else if (e instanceof EndOfStreamException) {</span>
<span class="fc" id="L1158">                            LOG.info(e.getMessage() + RETRY_CONN_MSG);</span>
<span class="fc bfc" id="L1159" title="All 2 branches covered.">                        } else if (e instanceof RWServerFoundException) {</span>
<span class="fc" id="L1160">                            LOG.info(e.getMessage());</span>
                        } else {
<span class="fc" id="L1162">                            LOG.warn(</span>
                                    &quot;Session 0x&quot;
<span class="fc" id="L1164">                                            + Long.toHexString(getSessionId())</span>
                                            + &quot; for server &quot;
<span class="fc" id="L1166">                                            + clientCnxnSocket.getRemoteSocketAddress()</span>
                                            + &quot;, unexpected error&quot;
                                            + RETRY_CONN_MSG, e);
                        }
<span class="fc" id="L1170">                        cleanup();</span>
<span class="fc bfc" id="L1171" title="All 2 branches covered.">                        if (state.isAlive()) {</span>
<span class="fc" id="L1172">                            eventThread.queueEvent(new WatchedEvent(</span>
                                    Event.EventType.None,
                                    Event.KeeperState.Disconnected,
                                    null));
                        }
<span class="fc" id="L1177">                        clientCnxnSocket.updateNow();</span>
<span class="fc" id="L1178">                        clientCnxnSocket.updateLastSendAndHeard();</span>
                    }
<span class="fc" id="L1180">                }</span>
            }
<span class="fc" id="L1182">            cleanup();</span>
<span class="fc" id="L1183">            clientCnxnSocket.close();</span>
<span class="fc bfc" id="L1184" title="All 2 branches covered.">            if (state.isAlive()) {</span>
<span class="fc" id="L1185">                eventThread.queueEvent(new WatchedEvent(Event.EventType.None,</span>
                        Event.KeeperState.Disconnected, null));
            }
<span class="fc" id="L1188">            ZooTrace.logTraceMessage(LOG, ZooTrace.getTextTraceLevel(),</span>
                    &quot;SendThread exited loop for session: 0x&quot;
<span class="fc" id="L1190">                           + Long.toHexString(getSessionId()));</span>
<span class="fc" id="L1191">        }</span>

        private void pingRwServer() throws RWServerFoundException {
<span class="fc" id="L1194">            String result = null;</span>
<span class="fc" id="L1195">            InetSocketAddress addr = hostProvider.next(0);</span>
<span class="fc" id="L1196">            LOG.info(&quot;Checking server &quot; + addr + &quot; for being r/w.&quot; +</span>
                    &quot; Timeout &quot; + pingRwTimeout);

<span class="fc" id="L1199">            Socket sock = null;</span>
<span class="fc" id="L1200">            BufferedReader br = null;</span>
            try {
<span class="fc" id="L1202">                sock = new Socket(addr.getHostName(), addr.getPort());</span>
<span class="fc" id="L1203">                sock.setSoLinger(false, -1);</span>
<span class="fc" id="L1204">                sock.setSoTimeout(1000);</span>
<span class="fc" id="L1205">                sock.setTcpNoDelay(true);</span>
<span class="fc" id="L1206">                sock.getOutputStream().write(&quot;isro&quot;.getBytes());</span>
<span class="fc" id="L1207">                sock.getOutputStream().flush();</span>
<span class="fc" id="L1208">                sock.shutdownOutput();</span>
<span class="fc" id="L1209">                br = new BufferedReader(</span>
<span class="fc" id="L1210">                        new InputStreamReader(sock.getInputStream()));</span>
<span class="fc" id="L1211">                result = br.readLine();</span>
<span class="fc" id="L1212">            } catch (ConnectException e) {</span>
                // ignore, this just means server is not up
<span class="nc" id="L1214">            } catch (IOException e) {</span>
                // some unexpected error, warn about it
<span class="nc" id="L1216">                LOG.warn(&quot;Exception while seeking for r/w server &quot; +</span>
<span class="nc" id="L1217">                        e.getMessage(), e);</span>
            } finally {
<span class="pc bpc" id="L1219" title="6 of 8 branches missed.">                if (sock != null) {</span>
                    try {
<span class="pc" id="L1221">                        sock.close();</span>
<span class="nc" id="L1222">                    } catch (IOException e) {</span>
<span class="nc" id="L1223">                        LOG.warn(&quot;Unexpected exception&quot;, e);</span>
<span class="pc" id="L1224">                    }</span>
                }
<span class="pc bpc" id="L1226" title="6 of 8 branches missed.">                if (br != null) {</span>
                    try {
<span class="pc" id="L1228">                        br.close();</span>
<span class="nc" id="L1229">                    } catch (IOException e) {</span>
<span class="nc" id="L1230">                        LOG.warn(&quot;Unexpected exception&quot;, e);</span>
<span class="pc" id="L1231">                    }</span>
                }
            }

<span class="fc bfc" id="L1235" title="All 2 branches covered.">            if (&quot;rw&quot;.equals(result)) {</span>
<span class="fc" id="L1236">                pingRwTimeout = minPingRwTimeout;</span>
                // save the found address so that it's used during the next
                // connection attempt
<span class="fc" id="L1239">                rwServerAddress = addr;</span>
<span class="fc" id="L1240">                throw new RWServerFoundException(&quot;Majority server found at &quot;</span>
<span class="fc" id="L1241">                        + addr.getHostName() + &quot;:&quot; + addr.getPort());</span>
            }
<span class="fc" id="L1243">        }</span>

        private void cleanup() {
<span class="fc" id="L1246">            clientCnxnSocket.cleanup();</span>
<span class="fc" id="L1247">            synchronized (pendingQueue) {</span>
<span class="fc bfc" id="L1248" title="All 2 branches covered.">                for (Packet p : pendingQueue) {</span>
<span class="fc" id="L1249">                    conLossPacket(p);</span>
<span class="fc" id="L1250">                }</span>
<span class="fc" id="L1251">                pendingQueue.clear();</span>
<span class="pc" id="L1252">            }</span>
<span class="fc" id="L1253">            synchronized (outgoingQueue) {</span>
<span class="fc bfc" id="L1254" title="All 2 branches covered.">                for (Packet p : outgoingQueue) {</span>
<span class="fc" id="L1255">                    conLossPacket(p);</span>
<span class="fc" id="L1256">                }</span>
<span class="fc" id="L1257">                outgoingQueue.clear();</span>
<span class="pc" id="L1258">            }</span>
<span class="fc" id="L1259">        }</span>

        /**
         * Callback invoked by the ClientCnxnSocket once a connection has been
         * established.
         * 
         * @param _negotiatedSessionTimeout
         * @param _sessionId
         * @param _sessionPasswd
         * @param isRO
         * @throws IOException
         */
        void onConnected(int _negotiatedSessionTimeout, long _sessionId,
                byte[] _sessionPasswd, boolean isRO) throws IOException {
<span class="fc" id="L1273">            negotiatedSessionTimeout = _negotiatedSessionTimeout;</span>
<span class="fc bfc" id="L1274" title="All 2 branches covered.">            if (negotiatedSessionTimeout &lt;= 0) {</span>
<span class="fc" id="L1275">                state = States.CLOSED;</span>

<span class="fc" id="L1277">                eventThread.queueEvent(new WatchedEvent(</span>
                        Watcher.Event.EventType.None,
                        Watcher.Event.KeeperState.Expired, null));
<span class="fc" id="L1280">                eventThread.queueEventOfDeath();</span>

                String warnInfo;
<span class="fc" id="L1283">                warnInfo = &quot;Unable to reconnect to ZooKeeper service, session 0x&quot;</span>
<span class="fc" id="L1284">                    + Long.toHexString(sessionId) + &quot; has expired&quot;;</span>
<span class="fc" id="L1285">                LOG.warn(warnInfo);</span>
<span class="fc" id="L1286">                throw new SessionExpiredException(warnInfo);</span>
            }
<span class="pc bpc" id="L1288" title="1 of 4 branches missed.">            if (!readOnly &amp;&amp; isRO) {</span>
<span class="nc" id="L1289">                LOG.error(&quot;Read/write client got connected to read-only server&quot;);</span>
            }
<span class="fc" id="L1291">            readTimeout = negotiatedSessionTimeout * 2 / 3;</span>
<span class="fc" id="L1292">            connectTimeout = negotiatedSessionTimeout / hostProvider.size();</span>
<span class="fc" id="L1293">            hostProvider.onConnected();</span>
<span class="fc" id="L1294">            sessionId = _sessionId;</span>
<span class="fc" id="L1295">            sessionPasswd = _sessionPasswd;</span>
<span class="fc bfc" id="L1296" title="All 2 branches covered.">            state = (isRO) ?</span>
                    States.CONNECTEDREADONLY : States.CONNECTED;
<span class="fc bfc" id="L1298" title="All 2 branches covered.">            seenRwServerBefore |= !isRO;</span>
<span class="fc" id="L1299">            LOG.info(&quot;Session establishment complete on server &quot;</span>
<span class="fc" id="L1300">                    + clientCnxnSocket.getRemoteSocketAddress()</span>
<span class="fc" id="L1301">                    + &quot;, sessionid = 0x&quot; + Long.toHexString(sessionId)</span>
<span class="fc bfc" id="L1302" title="All 2 branches covered.">                    + &quot;, negotiated timeout = &quot; + negotiatedSessionTimeout</span>
                    + (isRO ? &quot; (READ-ONLY mode)&quot; : &quot;&quot;));
<span class="fc bfc" id="L1304" title="All 2 branches covered.">            KeeperState eventState = (isRO) ?</span>
                    KeeperState.ConnectedReadOnly : KeeperState.SyncConnected;
<span class="fc" id="L1306">            eventThread.queueEvent(new WatchedEvent(</span>
                    Watcher.Event.EventType.None,
                    eventState, null));
<span class="fc" id="L1309">        }</span>

        void close() {
<span class="fc" id="L1312">            state = States.CLOSED;</span>
<span class="fc" id="L1313">            clientCnxnSocket.wakeupCnxn();</span>
<span class="fc" id="L1314">        }</span>

        void testableCloseSocket() throws IOException {
<span class="fc" id="L1317">            clientCnxnSocket.testableCloseSocket();</span>
<span class="fc" id="L1318">        }</span>

        public boolean clientTunneledAuthenticationInProgress() {
            // 1. SASL client is disabled.
<span class="pc bpc" id="L1322" title="1 of 2 branches missed.">            if (!ZooKeeperSaslClient.isEnabled()) {</span>
<span class="nc" id="L1323">                return false;</span>
            }

            // 2. SASL login failed.
<span class="fc bfc" id="L1327" title="All 2 branches covered.">            if (saslLoginFailed == true) {</span>
<span class="fc" id="L1328">                return false;</span>
            }

            // 3. SendThread has not created the authenticating object yet,
            // therefore authentication is (at the earliest stage of being) in progress.
<span class="pc bpc" id="L1333" title="1 of 2 branches missed.">            if (zooKeeperSaslClient == null) {</span>
<span class="nc" id="L1334">                return true;</span>
            }

            // 4. authenticating object exists, so ask it for its progress.
<span class="fc" id="L1338">            return zooKeeperSaslClient.clientTunneledAuthenticationInProgress();</span>
        }

        public void sendPacket(Packet p) throws IOException {
<span class="fc" id="L1342">            clientCnxnSocket.sendPacket(p);</span>
<span class="fc" id="L1343">        }</span>
    }

    /**
     * Shutdown the send/event threads. This method should not be called
     * directly - rather it should be called as part of close operation. This
     * method is primarily here to allow the tests to verify disconnection
     * behavior.
     */
    public void disconnect() {
<span class="pc bpc" id="L1353" title="1 of 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L1354">            LOG.debug(&quot;Disconnecting client for session: 0x&quot;</span>
<span class="nc" id="L1355">                      + Long.toHexString(getSessionId()));</span>
        }

<span class="fc" id="L1358">        sendThread.close();</span>
<span class="fc" id="L1359">        eventThread.queueEventOfDeath();</span>
<span class="fc" id="L1360">    }</span>

    /**
     * Close the connection, which includes; send session disconnect to the
     * server, shutdown the send/event threads.
     *
     * @throws IOException
     */
    public void close() throws IOException {
<span class="pc bpc" id="L1369" title="1 of 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L1370">            LOG.debug(&quot;Closing client for session: 0x&quot;</span>
<span class="nc" id="L1371">                      + Long.toHexString(getSessionId()));</span>
        }

        try {
<span class="fc" id="L1375">            RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1376">            h.setType(ZooDefs.OpCode.closeSession);</span>

<span class="fc" id="L1378">            submitRequest(h, null, null, null);</span>
<span class="fc" id="L1379">        } catch (InterruptedException e) {</span>
            // ignore, close the send/event threads
        } finally {
<span class="pc" id="L1382">            disconnect();</span>
<span class="fc" id="L1383">        }</span>
<span class="fc" id="L1384">    }</span>

<span class="fc" id="L1386">    private int xid = 1;</span>

<span class="fc" id="L1388">    private volatile States state = States.NOT_CONNECTED;</span>

    /*
     * getXid() is called externally by ClientCnxnNIO::doIO() when packets are sent from the outgoingQueue to
     * the server. Thus, getXid() must be public.
     */
    synchronized public int getXid() {
<span class="fc" id="L1395">        return xid++;</span>
    }

    public ReplyHeader submitRequest(RequestHeader h, Record request,
            Record response, WatchRegistration watchRegistration)
            throws InterruptedException {
<span class="fc" id="L1401">        ReplyHeader r = new ReplyHeader();</span>
<span class="fc" id="L1402">        Packet packet = queuePacket(h, r, request, response, null, null, null,</span>
                    null, watchRegistration);
<span class="fc" id="L1404">        synchronized (packet) {</span>
<span class="fc bfc" id="L1405" title="All 2 branches covered.">            while (!packet.finished) {</span>
<span class="fc" id="L1406">                packet.wait();</span>
            }
<span class="fc" id="L1408">        }</span>
<span class="fc" id="L1409">        return r;</span>
    }

    public void enableWrite() {
<span class="fc" id="L1413">        sendThread.getClientCnxnSocket().enableWrite();</span>
<span class="fc" id="L1414">    }</span>

    public void sendPacket(Record request, Record response, AsyncCallback cb, int opCode)
    throws IOException {
        // Generate Xid now because it will be sent immediately,
        // by call to sendThread.sendPacket() below.
<span class="fc" id="L1420">        int xid = getXid();</span>
<span class="fc" id="L1421">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1422">        h.setXid(xid);</span>
<span class="fc" id="L1423">        h.setType(opCode);</span>

<span class="fc" id="L1425">        ReplyHeader r = new ReplyHeader();</span>
<span class="fc" id="L1426">        r.setXid(xid);</span>

<span class="fc" id="L1428">        Packet p = new Packet(h, r, request, response, null, false);</span>
<span class="fc" id="L1429">        p.cb = cb;</span>
<span class="fc" id="L1430">        sendThread.sendPacket(p);</span>
<span class="fc" id="L1431">    }</span>

    Packet queuePacket(RequestHeader h, ReplyHeader r, Record request,
            Record response, AsyncCallback cb, String clientPath,
            String serverPath, Object ctx, WatchRegistration watchRegistration)
    {
<span class="fc" id="L1437">        Packet packet = null;</span>

        // Note that we do not generate the Xid for the packet yet. It is
        // generated later at send-time, by an implementation of ClientCnxnSocket::doIO(),
        // where the packet is actually sent.
<span class="fc" id="L1442">        synchronized (outgoingQueue) {</span>
<span class="fc" id="L1443">            packet = new Packet(h, r, request, response, watchRegistration);</span>
<span class="fc" id="L1444">            packet.cb = cb;</span>
<span class="fc" id="L1445">            packet.ctx = ctx;</span>
<span class="fc" id="L1446">            packet.clientPath = clientPath;</span>
<span class="fc" id="L1447">            packet.serverPath = serverPath;</span>
<span class="fc bfc" id="L1448" title="All 4 branches covered.">            if (!state.isAlive() || closing) {</span>
<span class="fc" id="L1449">                conLossPacket(packet);</span>
            } else {
                // If the client is asking to close the session then
                // mark as closing
<span class="fc bfc" id="L1453" title="All 2 branches covered.">                if (h.getType() == OpCode.closeSession) {</span>
<span class="fc" id="L1454">                    closing = true;</span>
                }
<span class="fc" id="L1456">                outgoingQueue.add(packet);</span>
            }
<span class="pc" id="L1458">        }</span>
<span class="fc" id="L1459">        sendThread.getClientCnxnSocket().wakeupCnxn();</span>
<span class="fc" id="L1460">        return packet;</span>
    }

    public void addAuthInfo(String scheme, byte auth[]) {
<span class="pc bpc" id="L1464" title="1 of 2 branches missed.">        if (!state.isAlive()) {</span>
<span class="nc" id="L1465">            return;</span>
        }
<span class="fc" id="L1467">        authInfo.add(new AuthData(scheme, auth));</span>
<span class="fc" id="L1468">        queuePacket(new RequestHeader(-4, OpCode.auth), null,</span>
                new AuthPacket(0, scheme, auth), null, null, null, null,
                null, null);
<span class="fc" id="L1471">    }</span>

    States getState() {
<span class="fc" id="L1474">        return state;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>